Index: uspace/srv/hid/output/proto/vt100.h
===================================================================
--- uspace/srv/hid/output/proto/vt100.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/hid/output/proto/vt100.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -35,7 +35,7 @@
 #include <io/charfield.h>
 
-typedef void (*vt100_putchar_t)(wchar_t ch);
-typedef void (*vt100_control_puts_t)(const char *str);
-typedef void (*vt100_flush_t)(void);
+typedef void (* vt100_putchar_t)(wchar_t ch);
+typedef void (* vt100_control_puts_t)(const char *str);
+typedef void (* vt100_flush_t)(void);
 
 typedef struct {
@@ -56,6 +56,6 @@
 extern void vt100_state_destroy(vt100_state_t *);
 
-extern errno_t vt100_yield(vt100_state_t *);
-extern errno_t vt100_claim(vt100_state_t *);
+extern int vt100_yield(vt100_state_t *);
+extern int vt100_claim(vt100_state_t *);
 extern void vt100_get_dimensions(vt100_state_t *, sysarg_t *, sysarg_t *);
 
Index: uspace/srv/hid/remcons/remcons.c
===================================================================
--- uspace/srv/hid/remcons/remcons.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/hid/remcons/remcons.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,5 +49,4 @@
 #include <io/console.h>
 #include <inttypes.h>
-#include <str.h>
 #include "telnet.h"
 #include "user.h"
@@ -71,14 +70,14 @@
     sizeof(telnet_force_character_mode_command) / sizeof(telnet_cmd_t);
 
-static errno_t remcons_open(con_srvs_t *, con_srv_t *);
-static errno_t remcons_close(con_srv_t *);
-static errno_t remcons_write(con_srv_t *, void *, size_t, size_t *);
+static int remcons_open(con_srvs_t *, con_srv_t *);
+static int remcons_close(con_srv_t *);
+static int remcons_write(con_srv_t *, void *, size_t);
 static void remcons_sync(con_srv_t *);
 static void remcons_clear(con_srv_t *);
 static void remcons_set_pos(con_srv_t *, sysarg_t col, sysarg_t row);
-static errno_t remcons_get_pos(con_srv_t *, sysarg_t *, sysarg_t *);
-static errno_t remcons_get_size(con_srv_t *, sysarg_t *, sysarg_t *);
-static errno_t remcons_get_color_cap(con_srv_t *, console_caps_t *);
-static errno_t remcons_get_event(con_srv_t *, cons_event_t *);
+static int remcons_get_pos(con_srv_t *, sysarg_t *, sysarg_t *);
+static int remcons_get_size(con_srv_t *, sysarg_t *, sysarg_t *);
+static int remcons_get_color_cap(con_srv_t *, console_caps_t *);
+static int remcons_get_event(con_srv_t *, cons_event_t *);
 
 static con_ops_t con_ops = {
@@ -115,5 +114,5 @@
 }
 
-static errno_t remcons_open(con_srvs_t *srvs, con_srv_t *srv)
+static int remcons_open(con_srvs_t *srvs, con_srv_t *srv)
 {
 	telnet_user_t *user = srv_to_user(srv);
@@ -128,5 +127,5 @@
 }
 
-static errno_t remcons_close(con_srv_t *srv)
+static int remcons_close(con_srv_t *srv)
 {
 	telnet_user_t *user = srv_to_user(srv);
@@ -138,8 +137,8 @@
 }
 
-static errno_t remcons_write(con_srv_t *srv, void *data, size_t size, size_t *nwritten)
-{
-	telnet_user_t *user = srv_to_user(srv);
-	errno_t rc;
+static int remcons_write(con_srv_t *srv, void *data, size_t size)
+{
+	telnet_user_t *user = srv_to_user(srv);
+	int rc;
 
 	rc = telnet_user_send_data(user, data, size);
@@ -147,6 +146,5 @@
 		return rc;
 
-	*nwritten = size;
-	return EOK;
+	return size;
 }
 
@@ -168,5 +166,5 @@
 }
 
-static errno_t remcons_get_pos(con_srv_t *srv, sysarg_t *col, sysarg_t *row)
+static int remcons_get_pos(con_srv_t *srv, sysarg_t *col, sysarg_t *row)
 {
 	telnet_user_t *user = srv_to_user(srv);
@@ -178,5 +176,5 @@
 }
 
-static errno_t remcons_get_size(con_srv_t *srv, sysarg_t *cols, sysarg_t *rows)
+static int remcons_get_size(con_srv_t *srv, sysarg_t *cols, sysarg_t *rows)
 {
 	(void) srv;
@@ -188,5 +186,5 @@
 }
 
-static errno_t remcons_get_color_cap(con_srv_t *srv, console_caps_t *ccaps)
+static int remcons_get_color_cap(con_srv_t *srv, console_caps_t *ccaps)
 {
 	(void) srv;
@@ -196,9 +194,9 @@
 }
 
-static errno_t remcons_get_event(con_srv_t *srv, cons_event_t *event)
+static int remcons_get_event(con_srv_t *srv, cons_event_t *event)
 {
 	telnet_user_t *user = srv_to_user(srv);
 	kbd_event_t kevent;
-	errno_t rc;
+	int rc;
 
 	rc = telnet_user_get_next_keyboard_event(user, &kevent);
@@ -233,5 +231,5 @@
  * @param arg Corresponding @c telnet_user_t structure.
  */
-static errno_t spawn_task_fibril(void *arg)
+static int spawn_task_fibril(void *arg)
 {
 	telnet_user_t *user = arg;
@@ -239,5 +237,5 @@
 	task_id_t task;
 	task_wait_t wait;
-	errno_t rc = task_spawnl(&task, &wait, APP_GETTERM, APP_GETTERM, user->service_name,
+	int rc = task_spawnl(&task, &wait, APP_GETTERM, APP_GETTERM, user->service_name,
 	    "/loc", "--msg", "--", APP_SHELL, NULL);
 	if (rc != EOK) {
@@ -301,5 +299,5 @@
 	telnet_user_add(user);
 
-	errno_t rc = loc_service_register(user->service_name, &user->service_id);
+	int rc = loc_service_register(user->service_name, &user->service_id);
 	if (rc != EOK) {
 		telnet_user_error(user, "Unable to register %s with loc: %s.",
@@ -345,5 +343,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc;
+	int rc;
 	tcp_listener_t *lst;
 	tcp_t *tcp;
Index: uspace/srv/hid/remcons/user.c
===================================================================
--- uspace/srv/hid/remcons/user.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/hid/remcons/user.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -187,9 +187,9 @@
  * might be negative.
  */
-static errno_t telnet_user_recv_next_byte_no_lock(telnet_user_t *user, char *byte)
+static int telnet_user_recv_next_byte_no_lock(telnet_user_t *user, char *byte)
 {
 	/* No more buffered data? */
 	if (user->socket_buffer_len <= user->socket_buffer_pos) {
-		errno_t rc;
+		int rc;
 		size_t recv_length;
 
@@ -272,5 +272,5 @@
  * @return Error code.
  */
-errno_t telnet_user_get_next_keyboard_event(telnet_user_t *user, kbd_event_t *event)
+int telnet_user_get_next_keyboard_event(telnet_user_t *user, kbd_event_t *event)
 {
 	fibril_mutex_lock(&user->guard);
@@ -283,5 +283,5 @@
 		/* Skip zeros, bail-out on error. */
 		while (next_byte == 0) {
-			errno_t rc = telnet_user_recv_next_byte_no_lock(user, &next_byte);
+			int rc = telnet_user_recv_next_byte_no_lock(user, &next_byte);
 			if (rc != EOK) {
 				fibril_mutex_unlock(&user->guard);
@@ -339,5 +339,5 @@
  * @param size Size of @p data buffer in bytes.
  */
-static errno_t telnet_user_send_data_no_lock(telnet_user_t *user, uint8_t *data, size_t size)
+static int telnet_user_send_data_no_lock(telnet_user_t *user, uint8_t *data, size_t size)
 {
 	uint8_t *converted = malloc(3 * size + 1);
@@ -362,5 +362,5 @@
 
 
-	errno_t rc = tcp_conn_send(user->conn, converted, converted_size);
+	int rc = tcp_conn_send(user->conn, converted, converted_size);
 	free(converted);
 
@@ -374,9 +374,9 @@
  * @param size Size of @p data buffer in bytes.
  */
-errno_t telnet_user_send_data(telnet_user_t *user, uint8_t *data, size_t size)
+int telnet_user_send_data(telnet_user_t *user, uint8_t *data, size_t size)
 {
 	fibril_mutex_lock(&user->guard);
 
-	errno_t rc = telnet_user_send_data_no_lock(user, data, size);
+	int rc = telnet_user_send_data_no_lock(user, data, size);
 
 	fibril_mutex_unlock(&user->guard);
Index: uspace/srv/hid/remcons/user.h
===================================================================
--- uspace/srv/hid/remcons/user.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/hid/remcons/user.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -87,6 +87,6 @@
 extern bool telnet_user_is_zombie(telnet_user_t *);
 extern void telnet_user_notify_client_disconnected(telnet_user_t *);
-extern errno_t telnet_user_get_next_keyboard_event(telnet_user_t *, kbd_event_t *);
-extern errno_t telnet_user_send_data(telnet_user_t *, uint8_t *, size_t);
+extern int telnet_user_get_next_keyboard_event(telnet_user_t *, kbd_event_t *);
+extern int telnet_user_send_data(telnet_user_t *, uint8_t *, size_t);
 extern void telnet_user_update_cursor_x(telnet_user_t *, int);
 
Index: uspace/srv/hid/rfb/main.c
===================================================================
--- uspace/srv/hid/rfb/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/hid/rfb/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -35,5 +35,4 @@
 #include <inttypes.h>
 #include <io/log.h>
-#include <str.h>
 #include <task.h>
 
@@ -53,25 +52,25 @@
 static rfb_t rfb;
 
-static errno_t rfb_claim(visualizer_t *vs)
-{
-	return EOK;
-}
-
-static errno_t rfb_yield(visualizer_t *vs)
-{
-	return EOK;
-}
-
-static errno_t rfb_suspend(visualizer_t *vs)
-{
-	return EOK;
-}
-
-static errno_t rfb_wakeup(visualizer_t *vs)
-{
-	return EOK;
-}
-
-static errno_t rfb_handle_damage_pixels(visualizer_t *vs,
+static int rfb_claim(visualizer_t *vs)
+{
+	return EOK;
+}
+
+static int rfb_yield(visualizer_t *vs)
+{
+	return EOK;
+}
+
+static int rfb_suspend(visualizer_t *vs)
+{
+	return EOK;
+}
+
+static int rfb_wakeup(visualizer_t *vs)
+{
+	return EOK;
+}
+
+static int rfb_handle_damage_pixels(visualizer_t *vs,
     sysarg_t x0, sysarg_t y0, sysarg_t width, sysarg_t height,
     sysarg_t x_offset, sysarg_t y_offset)
@@ -127,5 +126,5 @@
 }
 
-static errno_t rfb_change_mode(visualizer_t *vs, vslmode_t new_mode)
+static int rfb_change_mode(visualizer_t *vs, vslmode_t new_mode)
 {
 	return EOK;
@@ -218,5 +217,5 @@
 	async_set_fallback_port_handler(client_connection, NULL);
 
-	errno_t rc = loc_server_register(NAME);
+	int rc = loc_server_register(NAME);
 	if (rc != EOK) {
 		printf("%s: Unable to register server.\n", NAME);
Index: uspace/srv/hid/rfb/rfb.c
===================================================================
--- uspace/srv/hid/rfb/rfb.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/hid/rfb/rfb.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -62,8 +62,8 @@
 
 /** Receive one character (with buffering) */
-static errno_t recv_char(tcp_conn_t *conn, char *c)
+static int recv_char(tcp_conn_t *conn, char *c)
 {
 	size_t nrecv;
-	errno_t rc;
+	int rc;
 
 	if (rbuf_out == rbuf_in) {
@@ -83,8 +83,8 @@
 
 /** Receive count characters (with buffering) */
-static errno_t recv_chars(tcp_conn_t *conn, char *c, size_t count)
+static int recv_chars(tcp_conn_t *conn, char *c, size_t count)
 {
 	for (size_t i = 0; i < count; i++) {
-		errno_t rc = recv_char(conn, c);
+		int rc = recv_char(conn, c);
 		if (rc != EOK)
 			return rc;
@@ -94,9 +94,9 @@
 }
 
-static errno_t recv_skip_chars(tcp_conn_t *conn, size_t count)
+static int recv_skip_chars(tcp_conn_t *conn, size_t count)
 {
 	for (size_t i = 0; i < count; i++) {
 		char c;
-		errno_t rc = recv_char(conn, &c);
+		int rc = recv_char(conn, &c);
 		if (rc != EOK)
 			return rc;
@@ -173,5 +173,5 @@
 }
 
-errno_t rfb_init(rfb_t *rfb, uint16_t width, uint16_t height, const char *name)
+int rfb_init(rfb_t *rfb, uint16_t width, uint16_t height, const char *name)
 {
 	memset(rfb, 0, sizeof(rfb_t));
@@ -196,5 +196,5 @@
 }
 
-errno_t rfb_set_size(rfb_t *rfb, uint16_t width, uint16_t height)
+int rfb_set_size(rfb_t *rfb, uint16_t width, uint16_t height)
 {
 	size_t new_size = width * height * sizeof(pixel_t);
@@ -216,5 +216,5 @@
 }
 
-static errno_t recv_message(tcp_conn_t *conn, char type, void *buf, size_t size)
+static int recv_message(tcp_conn_t *conn, char type, void *buf, size_t size)
 {
 	memcpy(buf, &type, 1);
@@ -435,5 +435,5 @@
 }
 
-static errno_t rfb_tile_encode_solid(rfb_t *rfb, cpixel_ctx_t *cpixel,
+static size_t rfb_tile_encode_solid(rfb_t *rfb, cpixel_ctx_t *cpixel,
     rfb_rectangle_t *tile, void *buf, size_t *size)
 {
@@ -476,5 +476,5 @@
 			uint8_t tile_enctype = RFB_TILE_ENCODING_SOLID;
 			size_t tile_size;
-			errno_t rc = rfb_tile_encode_solid(rfb, &cpixel, &tile, buf,
+			int rc = rfb_tile_encode_solid(rfb, &cpixel, &tile, buf,
 			    &tile_size);
 			if (rc != EOK) {
@@ -492,5 +492,5 @@
 }
 
-static errno_t rfb_send_framebuffer_update(rfb_t *rfb, tcp_conn_t *conn,
+static int rfb_send_framebuffer_update(rfb_t *rfb, tcp_conn_t *conn,
     bool incremental)
 {
@@ -556,5 +556,5 @@
 	
 	if (!rfb->pixel_format.true_color) {
-		errno_t rc = tcp_conn_send(conn, send_palette, send_palette_size);
+		int rc = tcp_conn_send(conn, send_palette, send_palette_size);
 		if (rc != EOK) {
 			free(buf);
@@ -563,5 +563,5 @@
 	}
 	
-	errno_t rc = tcp_conn_send(conn, buf, buf_size);
+	int rc = tcp_conn_send(conn, buf, buf_size);
 	free(buf);
 	
@@ -569,5 +569,5 @@
 }
 
-static errno_t rfb_set_pixel_format(rfb_t *rfb, rfb_pixel_format_t *pixel_format)
+static int rfb_set_pixel_format(rfb_t *rfb, rfb_pixel_format_t *pixel_format)
 {
 	rfb->pixel_format = *pixel_format;
@@ -599,8 +599,7 @@
 {
 	/* Version handshake */
-	errno_t rc = tcp_conn_send(conn, "RFB 003.008\n", 12);
-	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Failed sending server version: %s",
-		    str_error(rc));
+	int rc = tcp_conn_send(conn, "RFB 003.008\n", 12);
+	if (rc != EOK) {
+		log_msg(LOG_DEFAULT, LVL_WARN, "Failed sending server version %d", rc);
 		return;
 	}
@@ -609,6 +608,5 @@
 	rc = recv_chars(conn, client_version, 12);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Failed receiving client version: %s",
-		    str_error(rc));
+		log_msg(LOG_DEFAULT, LVL_WARN, "Failed receiving client version: %d", rc);
 		return;
 	}
@@ -628,5 +626,5 @@
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_WARN,
-		    "Failed sending security handshake: %s", str_error(rc));
+		    "Failed sending security handshake: %d", rc);
 		return;
 	}
@@ -635,6 +633,5 @@
 	rc = recv_char(conn, &selected_sec_type);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Failed receiving security type: %s",
-		    str_error(rc));
+		log_msg(LOG_DEFAULT, LVL_WARN, "Failed receiving security type: %d", rc);
 		return;
 	}
@@ -647,6 +644,5 @@
 	rc = tcp_conn_send(conn, &security_result, sizeof(uint32_t));
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Failed sending security result: %s",
-		    str_error(rc));
+		log_msg(LOG_DEFAULT, LVL_WARN, "Failed sending security result: %d", rc);
 		return;
 	}
@@ -656,6 +652,5 @@
 	rc = recv_char(conn, &shared_flag);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Failed receiving client init: %s",
-		    str_error(rc));
+		log_msg(LOG_DEFAULT, LVL_WARN, "Failed receiving client init: %d", rc);
 		return;
 	}
@@ -680,6 +675,5 @@
 	rc = tcp_conn_send(conn, server_init, msg_length);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Failed sending server init: %s",
-		    str_error(rc));
+		log_msg(LOG_DEFAULT, LVL_WARN, "Failed sending server init: %d", rc);
 		return;
 	}
@@ -759,10 +753,10 @@
 }
 
-errno_t rfb_listen(rfb_t *rfb, uint16_t port)
+int rfb_listen(rfb_t *rfb, uint16_t port)
 {
 	tcp_t *tcp = NULL;
 	tcp_listener_t *lst = NULL;
 	inet_ep_t ep;
-	errno_t rc;
+	int rc;
 	
 	rc = tcp_create(&tcp);
Index: uspace/srv/hid/rfb/rfb.h
===================================================================
--- uspace/srv/hid/rfb/rfb.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/hid/rfb/rfb.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -164,7 +164,7 @@
 
 
-extern errno_t rfb_init(rfb_t *, uint16_t, uint16_t, const char *);
-extern errno_t rfb_set_size(rfb_t *, uint16_t, uint16_t);
-extern errno_t rfb_listen(rfb_t *, uint16_t);
+extern int rfb_init(rfb_t *, uint16_t, uint16_t, const char *);
+extern int rfb_set_size(rfb_t *, uint16_t, uint16_t);
+extern int rfb_listen(rfb_t *, uint16_t);
 
 #endif
Index: uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c
===================================================================
--- uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -85,5 +85,5 @@
 	
 	async_set_fallback_port_handler(s3c24xx_ts_connection, NULL);
-	errno_t rc = loc_server_register(NAME);
+	int rc = loc_server_register(NAME);
 	if (rc != EOK) {
 		printf("%s: Unable to register driver.\n", NAME);
@@ -137,5 +137,5 @@
 	    (void *) ts->paddr, inr);
 
-	async_irq_subscribe(inr, s3c24xx_ts_irq_handler, NULL, &ts_irq_code, NULL);
+	async_irq_subscribe(inr, s3c24xx_ts_irq_handler, NULL, &ts_irq_code);
 
 	s3c24xx_ts_wait_for_int_mode(ts, updn_down);
Index: uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c
===================================================================
--- uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -69,6 +69,6 @@
 static void s3c24xx_uart_sendb(s3c24xx_uart_t *, uint8_t);
 
-static errno_t s3c24xx_uart_read(chardev_srv_t *, void *, size_t, size_t *);
-static errno_t s3c24xx_uart_write(chardev_srv_t *, const void *, size_t, size_t *);
+static int s3c24xx_uart_read(chardev_srv_t *, void *, size_t, size_t *);
+static int s3c24xx_uart_write(chardev_srv_t *, const void *, size_t, size_t *);
 
 static chardev_ops_t s3c24xx_uart_chardev_ops = {
@@ -82,5 +82,5 @@
 	
 	async_set_fallback_port_handler(s3c24xx_uart_connection, uart);
-	errno_t rc = loc_server_register(NAME);
+	int rc = loc_server_register(NAME);
 	if (rc != EOK) {
 		printf("%s: Unable to register server.\n", NAME);
@@ -124,5 +124,5 @@
 static void s3c24xx_uart_irq_handler(ipc_call_t *call, void *arg)
 {
-	errno_t rc;
+	int rc;
 
 	(void) call;
@@ -173,5 +173,5 @@
 	    (void *) uart->paddr, inr);
 
-	async_irq_subscribe(inr, s3c24xx_uart_irq_handler, NULL, &uart_irq_code, NULL);
+	async_irq_subscribe(inr, s3c24xx_uart_irq_handler, NULL, &uart_irq_code);
 
 	/* Enable FIFO, Tx trigger level: empty, Rx trigger level: 1 byte. */
@@ -200,5 +200,5 @@
 }
 
-static errno_t s3c24xx_uart_read(chardev_srv_t *srv, void *buf, size_t size,
+static int s3c24xx_uart_read(chardev_srv_t *srv, void *buf, size_t size,
     size_t *nread)
 {
@@ -206,5 +206,5 @@
 	size_t p;
 	uint8_t *bp = (uint8_t *) buf;
-	errno_t rc;
+	int rc;
 
 	fibril_mutex_lock(&uart->buf_lock);
@@ -227,5 +227,5 @@
 }
 
-static errno_t s3c24xx_uart_write(chardev_srv_t *srv, const void *data, size_t size,
+static int s3c24xx_uart_write(chardev_srv_t *srv, const void *data, size_t size,
     size_t *nwr)
 {
Index: uspace/srv/klog/klog.c
===================================================================
--- uspace/srv/klog/klog.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/klog/klog.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -100,12 +100,13 @@
 static void producer(void)
 {
-	size_t len = 0;
-	errno_t rc = klog_read(buffer, BUFFER_SIZE, &len);
-	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "klog_read failed, rc = %s",
-		    str_error_name(rc));
+	int read = klog_read(buffer, BUFFER_SIZE);
+	
+	if (read < 0) {
+		log_msg(LOG_DEFAULT, LVL_ERROR, "klog_read failed, rc = %d",
+		    read);
 		return;
 	}
 	
+	size_t len = read;
 	size_t offset = 0;
 	while (offset < len) {
@@ -146,5 +147,5 @@
  *
  */
-static errno_t consumer(void *data)
+static int consumer(void *data)
 {
 	
@@ -210,5 +211,5 @@
 int main(int argc, char *argv[])
 {
-	errno_t rc = log_init(NAME);
+	int rc = log_init(NAME);
 	if (rc != EOK) {
 		fprintf(stderr, "%s: Unable to initialize log\n", NAME);
Index: uspace/srv/loader/main.c
===================================================================
--- uspace/srv/loader/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/loader/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -119,5 +119,5 @@
 {
 	char *buf;
-	errno_t rc = async_data_write_accept((void **) &buf, true, 0, 0, 0, NULL);
+	int rc = async_data_write_accept((void **) &buf, true, 0, 0, 0, NULL);
 	
 	if (rc == EOK) {
@@ -146,5 +146,5 @@
 
 	char* name = malloc(namesize);
-	errno_t rc = async_data_write_finalize(writeid, name, namesize);
+	int rc = async_data_write_finalize(writeid, name, namesize);
 	if (rc != EOK) {
 		async_answer_0(rid, EINVAL);
@@ -152,7 +152,6 @@
 	}
 
-	int file;
-	rc = vfs_receive_handle(true, &file);
-	if (rc != EOK) {
+	int file = vfs_receive_handle(true);
+	if (file < 0) {
 		async_answer_0(rid, EINVAL);
 		return;
@@ -173,5 +172,5 @@
 	char *buf;
 	size_t buf_size;
-	errno_t rc = async_data_write_accept((void **) &buf, true, 0, 0, 0, &buf_size);
+	int rc = async_data_write_accept((void **) &buf, true, 0, 0, 0, &buf_size);
 	
 	if (rc == EOK) {
@@ -249,5 +248,5 @@
 
 	char* name = malloc(namesize);
-	errno_t rc = async_data_write_finalize(writeid, name, namesize);
+	int rc = async_data_write_finalize(writeid, name, namesize);
 	if (rc != EOK) {
 		async_answer_0(rid, EINVAL);
@@ -255,7 +254,6 @@
 	}
 
-	int file;
-	rc = vfs_receive_handle(true, &file);
-	if (rc != EOK) {
+	int file = vfs_receive_handle(true);
+	if (file < 0) {
 		async_answer_0(rid, EINVAL);
 		return;
@@ -300,5 +298,5 @@
 	pcb.inbox_entries = inbox_entries;
 	
-	async_answer_0(rid, EOK);
+	async_answer_0(rid, rc);
 	return 0;
 }
@@ -349,5 +347,5 @@
 	
 	while (true) {
-		errno_t retval;
+		int retval;
 		ipc_call_t call;
 		ipc_callid_t callid = async_get_call(&call);
@@ -395,5 +393,5 @@
 	/* Introduce this task to the NS (give it our task ID). */
 	task_id_t id = task_get_id();
-	errno_t rc = ns_intro(id);
+	int rc = ns_intro(id);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/locsrv/category.c
===================================================================
--- uspace/srv/locsrv/category.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/locsrv/category.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -56,5 +56,5 @@
 
 /** Get list of categories. */
-errno_t categ_dir_get_categories(categ_dir_t *cdir, category_id_t *id_buf,
+int categ_dir_get_categories(categ_dir_t *cdir, category_id_t *id_buf,
     size_t buf_size, size_t *act_size)
 {
@@ -107,5 +107,5 @@
 
 /** Add service to category. */
-errno_t category_add_service(category_t *cat, loc_service_t *svc)
+int category_add_service(category_t *cat, loc_service_t *svc)
 {
 	assert(fibril_mutex_is_locked(&cat->mutex));
@@ -171,5 +171,5 @@
 
 /** Get list of services in category. */
-errno_t category_get_services(category_t *cat, service_id_t *id_buf,
+int category_get_services(category_t *cat, service_id_t *id_buf,
     size_t buf_size, size_t *act_size)
 {
Index: uspace/srv/locsrv/category.h
===================================================================
--- uspace/srv/locsrv/category.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/locsrv/category.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -82,12 +82,12 @@
 extern void categ_dir_init(categ_dir_t *);
 extern void categ_dir_add_cat(categ_dir_t *, category_t *);
-extern errno_t categ_dir_get_categories(categ_dir_t *, service_id_t *, size_t,
+extern int categ_dir_get_categories(categ_dir_t *, service_id_t *, size_t,
     size_t *);
 extern category_t *category_new(const char *);
-extern errno_t category_add_service(category_t *, loc_service_t *);
+extern int category_add_service(category_t *, loc_service_t *);
 extern void category_remove_service(svc_categ_t *);
 extern category_t *category_get(categ_dir_t *, catid_t);
 extern category_t *category_find_by_name(categ_dir_t *, const char *);
-extern errno_t category_get_services(category_t *, service_id_t *, size_t,
+extern int category_get_services(category_t *, service_id_t *, size_t,
     size_t *);
 
Index: uspace/srv/locsrv/locsrv.c
===================================================================
--- uspace/srv/locsrv/locsrv.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/locsrv/locsrv.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -47,5 +47,4 @@
 #include <stdlib.h>
 #include <str.h>
-#include <str_error.h>
 #include <ipc/loc.h>
 #include <assert.h>
@@ -356,5 +355,5 @@
 	 * Get server name
 	 */
-	errno_t rc = async_data_write_accept((void **) &server->name, true, 0,
+	int rc = async_data_write_accept((void **) &server->name, true, 0,
 	    LOC_NAME_MAXLEN, 0, NULL);
 	if (rc != EOK) {
@@ -410,5 +409,5 @@
  *
  */
-static errno_t loc_server_unregister(loc_server_t *server)
+static int loc_server_unregister(loc_server_t *server)
 {
 	if (server == NULL)
@@ -471,5 +470,5 @@
 	/* Get fqsn */
 	char *fqsn;
-	errno_t rc = async_data_write_accept((void **) &fqsn, true, 0,
+	int rc = async_data_write_accept((void **) &fqsn, true, 0,
 	    LOC_NAME_MAXLEN, 0, NULL);
 	if (rc != EOK) {
@@ -599,5 +598,5 @@
 	}
 	
-	errno_t retval = async_data_read_finalize(callid, cat->name,
+	sysarg_t retval = async_data_read_finalize(callid, cat->name,
 	    min(size, act_size));
 	
@@ -647,5 +646,5 @@
 	}
 	
-	errno_t retval = async_data_read_finalize(callid, fqn,
+	sysarg_t retval = async_data_read_finalize(callid, fqn,
 	    min(size, act_size));
 	free(fqn);
@@ -694,5 +693,5 @@
 	}
 	
-	errno_t retval = async_data_read_finalize(callid, svc->server->name,
+	sysarg_t retval = async_data_read_finalize(callid, svc->server->name,
 	    min(size, act_size));
 	
@@ -743,5 +742,5 @@
 	
 	/* Get fqsn */
-	errno_t rc = async_data_write_accept((void **) &fqsn, true, 0,
+	int rc = async_data_write_accept((void **) &fqsn, true, 0,
 	    LOC_NAME_MAXLEN, 0, NULL);
 	if (rc != EOK) {
@@ -806,5 +805,5 @@
 	
 	/* Get service name */
-	errno_t rc = async_data_write_accept((void **) &name, true, 0,
+	int rc = async_data_write_accept((void **) &name, true, 0,
 	    LOC_NAME_MAXLEN, 0, NULL);
 	if (rc != EOK) {
@@ -851,5 +850,5 @@
  * events.
  *
- * On success, answer will contain EOK errno_t retval.
+ * On success, answer will contain EOK int retval.
  * On failure, error code will be sent in retval.
  *
@@ -895,5 +894,5 @@
 /** Find ID for category specified by name.
  *
- * On success, answer will contain EOK errno_t retval and service ID in arg1.
+ * On success, answer will contain EOK int retval and service ID in arg1.
  * On failure, error code will be sent in retval.
  *
@@ -905,5 +904,5 @@
 	
 	/* Get service name */
-	errno_t rc = async_data_write_accept((void **) &name, true, 0,
+	int rc = async_data_write_accept((void **) &name, true, 0,
 	    LOC_NAME_MAXLEN, 0, NULL);
 	if (rc != EOK) {
@@ -972,5 +971,5 @@
 	size_t size;
 	size_t act_size;
-	errno_t rc;
+	int rc;
 	
 	if (!async_data_read_receive(&callid, &size)) {
@@ -1000,5 +999,5 @@
 	fibril_mutex_unlock(&cdir.mutex);
 	
-	errno_t retval = async_data_read_finalize(callid, id_buf, size);
+	sysarg_t retval = async_data_read_finalize(callid, id_buf, size);
 	free(id_buf);
 	
@@ -1047,5 +1046,5 @@
 	}
 	
-	errno_t retval = async_data_read_finalize(callid, desc, size);
+	sysarg_t retval = async_data_read_finalize(callid, desc, size);
 	
 	free(desc);
@@ -1110,5 +1109,5 @@
 	}
 	
-	errno_t retval = async_data_read_finalize(callid, desc, size);
+	sysarg_t retval = async_data_read_finalize(callid, desc, size);
 	
 	free(desc);
@@ -1123,5 +1122,5 @@
 	size_t size;
 	size_t act_size;
-	errno_t rc;
+	int rc;
 	
 	if (!async_data_read_receive(&callid, &size)) {
@@ -1163,5 +1162,5 @@
 	fibril_mutex_unlock(&cdir.mutex);
 	
-	errno_t retval = async_data_read_finalize(callid, id_buf, size);
+	sysarg_t retval = async_data_read_finalize(callid, id_buf, size);
 	free(id_buf);
 	
@@ -1278,5 +1277,5 @@
 	catid_t cat_id;
 	service_id_t svc_id;
-	errno_t retval;
+	sysarg_t retval;
 	
 	svc_id = IPC_GET_ARG1(*icall);
@@ -1528,17 +1527,13 @@
 	
 	port_id_t port;
-	errno_t rc = async_create_port(INTERFACE_LOC_SUPPLIER,
+	int rc = async_create_port(INTERFACE_LOC_SUPPLIER,
 	    loc_connection_supplier, NULL, &port);
-	if (rc != EOK) {
-		printf("%s: Error while creating supplier port: %s\n", NAME, str_error(rc));
+	if (rc != EOK)
 		return rc;
-	}
 	
 	rc = async_create_port(INTERFACE_LOC_CONSUMER,
 	    loc_connection_consumer, NULL, &port);
-	if (rc != EOK) {
-		printf("%s: Error while creating consumer port: %s\n", NAME, str_error(rc));
+	if (rc != EOK)
 		return rc;
-	}
 	
 	/* Set a handler of incomming connections */
@@ -1547,8 +1542,6 @@
 	/* Register location service at naming service */
 	rc = service_register(SERVICE_LOC);
-	if (rc != EOK) {
-		printf("%s: Error while registering service: %s\n", NAME, str_error(rc));
+	if (rc != EOK)
 		return rc;
-	}
 	
 	printf("%s: Accepting connections\n", NAME);
Index: uspace/srv/logger/ctl.c
===================================================================
--- uspace/srv/logger/ctl.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/logger/ctl.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,8 +43,8 @@
 #include "logger.h"
 
-static errno_t handle_log_level_change(sysarg_t new_level)
+static int handle_log_level_change(sysarg_t new_level)
 {
 	void *full_name;
-	errno_t rc = async_data_write_accept(&full_name, true, 0, 0, 0, NULL);
+	int rc = async_data_write_accept(&full_name, true, 0, 0, 0, NULL);
 	if (rc != EOK) {
 		return rc;
@@ -77,21 +77,17 @@
 		switch (IPC_GET_IMETHOD(call)) {
 		case LOGGER_CONTROL_SET_DEFAULT_LEVEL: {
-			errno_t rc = set_default_logging_level(IPC_GET_ARG1(call));
+			int rc = set_default_logging_level(IPC_GET_ARG1(call));
 			async_answer_0(callid, rc);
 			break;
 		}
 		case LOGGER_CONTROL_SET_LOG_LEVEL: {
-			errno_t rc = handle_log_level_change(IPC_GET_ARG1(call));
+			int rc = handle_log_level_change(IPC_GET_ARG1(call));
 			async_answer_0(callid, rc);
 			break;
 		}
 		case LOGGER_CONTROL_SET_ROOT: {
-			int fd;
-			errno_t rc = vfs_receive_handle(true, &fd);
-			if (rc == EOK) {
-				rc = vfs_root_set(fd);
-				vfs_put(fd);
-			}
-			async_answer_0(callid, rc);
+			int fd = vfs_receive_handle(true);
+			vfs_root_set(fd);
+			async_answer_0(callid, fd >= 0 ? EOK : fd);
 			break;
 		}
Index: uspace/srv/logger/initlvl.c
===================================================================
--- uspace/srv/logger/initlvl.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/logger/initlvl.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -50,5 +50,5 @@
 	if (value == NULL) {
 		log_level_t level;
-		errno_t rc = log_level_from_str(key, &level);
+		int rc = log_level_from_str(key, &level);
 		if (rc != EOK)
 			return;
@@ -59,5 +59,5 @@
 
 	log_level_t level;
-	errno_t rc = log_level_from_str(value, &level);
+	int rc = log_level_from_str(value, &level);
 	if (rc != EOK)
 		return;
Index: uspace/srv/logger/level.c
===================================================================
--- uspace/srv/logger/level.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/logger/level.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,5 +49,5 @@
 }
 
-errno_t set_default_logging_level(log_level_t new_level)
+int set_default_logging_level(log_level_t new_level)
 {
 	if (new_level >= LVL_LIMIT)
Index: uspace/srv/logger/logger.h
===================================================================
--- uspace/srv/logger/logger.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/logger/logger.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -95,5 +95,5 @@
 
 log_level_t get_default_logging_level(void);
-errno_t set_default_logging_level(log_level_t);
+int set_default_logging_level(log_level_t);
 
 
